/*$T indentinput.cpp GC 1.140 04/13/11 21:54:37 */

/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    Modify and cleanup by Binh Nguyen.
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */

#include <sys/time.h>
#include <iostream>
#include <vector>
#include <bitset>
#include <ctime>
#include <stdlib.h>
#include <fstream>
#include "hash_element.h"

using namespace std;

// Implement your bloom filter here
//
//

/*
 =======================================================================================================================
 =======================================================================================================================
 */

void print_list(const vector<tIpAddress> &some_list)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	vector<tIpAddress>::const_iterator	it;
	tIpAddress::const_iterator			it_inner;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	for(it = some_list.begin(); it != some_list.end(); it++)
	{
		for(it_inner = it->begin(); it_inner != it->end(); it_inner++)
		{
			cout << *it_inner << " ";
		}

		cout << endl;
	}
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
int main(int argc, char *argv[])
{
	/*
	 * Reading input and parametters here. ;
	 * Do not modify unless you know what you are doing.
	 */
	if(argc != 7)
	{
		cerr <<
			"usage: "<< argv[0] << " <ip_file> <ip_test> <table_size> <num_elements> <num_test_ele> <num_hash>" <<
			endl;
		exit(1);
	}

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	/* Parameters */
	int num_ips = 0;
	int num_elements = atoi(argv[4]);
	int num_ip_components;
	int num_test_ele = atoi(argv[5]);
	int num_hash_functions = atoi(argv[6]);
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	num_ip_components = 4;

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	/* Table size */
	int								N = atoi(argv[3]);
	/* General variables */
	int								i, j;
	vector<tIpAddress>::iterator	it, it2;
	tIpAddress::iterator			it_inner, it_inner2;
	/* Populate the IPs */
	vector<tIpAddress>				ip_list, ip_test_list;
	ifstream						fin, tfin;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	fin.open(argv[1]);
	if(!fin)
	{
		cerr << "Error: " << argv[1] << " could not be opened" << endl;
		exit(1);
	}

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	string::size_type	gap_pos, sub_length;
	string				line, sub_ip_str;
	int					num_test_ip = -1;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	num_ips = -1;
	while(!fin.eof() && num_ips < num_elements)
	{
		getline(fin, line);

		/*~~~~~~~~~~~*/
		tIpAddress	ip;
		/*~~~~~~~~~~~*/

		i = 0;
		for(j = 0; j < num_ip_components; j++)
		{
			gap_pos = line.find_first_of(" ", i);
			sub_length = gap_pos - i;
			sub_ip_str = line.substr(i, sub_length);
			ip.push_back(atoi(sub_ip_str.c_str()));
			i = gap_pos + 1;
		}

		ip_list.push_back(ip);
		num_ips++;
	}

	fin.close();
	tfin.open(argv[2]);
	if(!tfin)
	{
		cerr << "Error: " << argv[2] << " could not be opened" << endl;
		exit(1);
	}

	while(!tfin.eof() && num_test_ip < num_test_ele)
	{
		getline(tfin, line);

		/*~~~~~~~~~~~*/
		tIpAddress	ip;
		/*~~~~~~~~~~~*/

		i = 0;
		for(j = 0; j < num_ip_components; j++)
		{
			gap_pos = line.find_first_of(" ", i);
			sub_length = gap_pos - i;
			sub_ip_str = line.substr(i, sub_length);
			ip.push_back(atoi(sub_ip_str.c_str()));
			i = gap_pos + 1;
		}

		ip_test_list.push_back(ip);
		num_test_ip++;
	}

	tfin.close();

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	/* get the time right before we begin inserting elements DO NOT CHANGE */
	struct timeval	pre_insert, post_insert, post_algo;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	/*
	 * Initialize your bloom filter here. ;
	 * INSERT bloom filter creation/ initialization here ;*/

	 /*
	 * END
	 */
	gettimeofday(&pre_insert, NULL);

	/*
	 * inserting ip list into Bloom filter here ;
	 */

	for(it = ip_list.begin(); it != ip_list.end(); it++)
	{
		//b.insert(*it);
	}

	 /*
	 * END ;
	 * get the time right after we finish inserting elements DO NOT CHANGE
	 */
	gettimeofday(&post_insert, NULL);

	/*
	 * TESTING bloom filter here ;
	 */

	/*~~~~~~~~~~~~~~*/
	int hit_count = 0; // false positive
	/*~~~~~~~~~~~~~~*/

	for(it = ip_test_list.begin(); it != ip_test_list.end(); it++)
	{
		//if(b.check(*it))
		//{
		//	hit_count++;
		//}
	}

	 /*
	 * END ;
	 * Finish up and return. DO NOT CHANGE
	 */
	gettimeofday(&post_algo, NULL);

	/*~~~~~~~~~~~~~~~~~~~~~~*/
	long	seconds, useconds;
	/*~~~~~~~~~~~~~~~~~~~~~~*/

	seconds = post_insert.tv_sec - pre_insert.tv_sec;
	useconds = post_insert.tv_usec - pre_insert.tv_usec;

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	double	insert_time = ((seconds) * 1000 + useconds / 1000.0) + 0.5;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	seconds = post_algo.tv_sec - post_insert.tv_sec;
	useconds = post_algo.tv_usec - post_insert.tv_usec;

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	double	test_time = ((seconds) * 1000 + useconds / 1000.0) + 0.5;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	cout << "insert_time=" << insert_time << " test_time = "
	     << test_time << " num false positive " << hit_count << endl;

	return 0;
}
