/*$T indentinput.cpp GC 1.140 04/13/11 21:38:21 */


/*$6
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  Modify and cleanup by Binh Nguyen.

 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 */


#include <iostream>
#include "hash_element.h"

using namespace std;

/*
 =======================================================================================================================
 =======================================================================================================================
 */

Hash_element::Hash_element()
{
	element_size = 0;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
Hash_element::~Hash_element()
{

	/*
	 * delete values;
	 */
}

/*
 =======================================================================================================================
    the method returns false if the ip is not in this hash element ;
    Otherwise, true is returned.
 =======================================================================================================================
 */
bool Hash_element::isValueContained(tIpAddress &ip)
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	vector<tIpAddress>::iterator	ip_values;
	tIpAddress::iterator			ip_inner, value_inner;
	int								found;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	/* check if a given ip address is in */
	for(ip_values = values.begin(); ip_values != values.end(); ip_values++)
	{
		ip_inner = ip.begin();
		found = 1;
		for(value_inner = ip_values->begin(); value_inner != ip_values->end(); value_inner++)
		{
			if(ip_inner == ip.end())
			{
				found = 0;
			}

			if(*value_inner != *ip_inner)
			{
				found = 0;
			}

			ip_inner++;
		}

		if(found == 1)
		{
			return true;
		}
	}

	/* No match */
	return false;
}

/*
 =======================================================================================================================
    insert ip into the chain
 =======================================================================================================================
 */
bool Hash_element::insertValue(tIpAddress &ip)
{

	/*
	 * checking if the ip is already in the value ;
	 * if it is, it cannot be added again
	 */
	if(isValueContained(ip)) return false;
	values.push_back(ip);
	element_size++;
	return true;
}

/*
 =======================================================================================================================
    intended for removing element (unfinish)
 =======================================================================================================================
 */
bool Hash_element::remove(tIpAddress &ip)
{
	return true;
}

/*
 =======================================================================================================================
 =======================================================================================================================
 */
int Hash_element::getSize()
{
	return element_size;
}

/*
 =======================================================================================================================
    print all ips on the chain
 =======================================================================================================================
 */
void Hash_element::print()
{
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	vector<tIpAddress>::iterator	it;
	tIpAddress::iterator			it_inner;
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

	for(it = values.begin(); it != values.end(); it++)
	{
		for(it_inner = it->begin(); it_inner != it->end(); it_inner++)
		{
			cout << *it_inner << " ";
		}

		cout << endl;
	}
}
